<?php 
namespace Teknisa\MAN\Controllers\DataExporterImpl\ReportHandlers;

use Zeedhi\Framework\DTO\Response;

class RelEntregasPorMotoboyHandler extends AReportHandler {
    
    const RELATORIO = 'orm00006_relEntregasPorMotoboyExport';
    const RELATORIOCONS = 'orm00006_relEntregasPorMotoboyConsExport';
    
    public function buildNewRequest($request, Response $response) {
        $conditions = $this->relService->getParamsAsArray($request);
        $tipoRelatorio = self::RELATORIO;
        if(array_key_exists('CDFILIAL', $conditions)){
            $conditions['CDFILIAL'] = implode('_', $conditions['CDFILIAL']);
            $conditions['TCDFILIAL'] = NULL;
        } else{
            $conditions['CDFILIAL'] = NULL;
            $conditions['TCDFILIAL'] = 'T';
        }
        if(array_key_exists('DTENTRVENDA', $conditions)){
            $conditions['DTVENDAINI'] = $conditions['DTENTRVENDA'][0];
            $conditions['DTVENDAFIN'] = $conditions['DTENTRVENDA'][1];
        }
        
        if(!array_key_exists('VRTAXAMOTO', $conditions)){
            $conditions['VRTAXAMOTO']=100;
        }
        unset($conditions['NRORG']);
        unset($conditions['DTENTRVENDA']);
        if($conditions['TIPORELATORIO'] == 'C'){
            $tipoRelatorio = self::RELATORIOCONS;
        }
        unset($conditions['TIPORELATORIO']);
        
        $newRequest = $this->relService->createNewZeedhiFilterRequestObject($request, $tipoRelatorio, $conditions);
        return [$newRequest, $response];
    }
}